package me.teridax.jcash;

import me.teridax.jcash.gui.Loader;
import me.teridax.jcash.gui.account.AccountController;
import me.teridax.jcash.gui.login.LoginController;

import javax.swing.*;

public class Main {

    private static Main instance;

    private final JFrame window;

    private Main() {
        window = new JFrame();
        window.setTitle("Bankautomat");
        window.setLocationByPlatform(true);
        window.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    }

    public static void main(String[] args) {
        instance();
        getInstance().popLoginScreen();
    }

    public static Main getInstance() {
        return instance;
    }

    public static void instance() {
        if (instance == null) {
            instance = new Main();
            return;
        }

        throw new IllegalStateException("me.teridax.jcash.Main is already initialized");
    }

    public void popLoginScreen() {
        SwingUtilities.invokeLater(() -> {
            var path = Loader.load();
            var login = new LoginController(path);

            login.addAccountSelectionListener(account -> {
                var profileCont = new AccountController(account);
                window.setContentPane(profileCont.getView());
                window.pack();
            });

            window.setContentPane(login.getView());
            window.pack();
            window.setVisible(true);
        });
    }

    public void logout() {
        window.setContentPane(new JLabel("you're logged out"));
        window.setVisible(false);
    }
}