package me.teridax.jcash.gui.account;

import me.teridax.jcash.Main;
import me.teridax.jcash.banking.Profile;

public class AccountController {

    private final AccountView view;

    public AccountController(Profile profile) {
        this.view = new AccountView();
        this.view.setProfile(profile);

        createListeners(profile);
    }

    private void createListeners(Profile profile) {
        this.view.getAccountSelection().addActionListener(e -> {
            var description = ((String) this.view.getAccountSelection().getSelectedItem());
            profile.setPrimaryAccount(description);
            this.view.setProfile(profile);
        });

        this.view.getLogout().addActionListener(e -> {
            Main.getInstance().logout();
            Main.getInstance().popLoginScreen();
        });
    }

    public AccountView getView() {
        return view;
    }
}
